//	*******************************************************************************
//	Name	:	username.hxx
//			:	user name
//	Author	:	I. Nakagawa
//	Create	:	2023/04/17
//	Modify	:	2023/04/17	
//	*******************************************************************************

#pragma		once

#include	"_s_func.hxx"
#include	"i_define.hxx"

#ifdef		_WIN32
#include	<Windows.h>
#endif

////
//	*******************************************************************************
//	Get user name
//	Create	:	2023/04/17
//	*******************************************************************************
inline	tstring	Get_user_name	(void)
{
	tstring	user_name ;
	#ifdef	_WIN32
	{
		#ifdef	UNLEN
		DWORD	size = UNLEN + 1 ;
		#else
		DWORD	size = 256 + 1 ;
		#endif
		user_name.resize(size,0) ;
		::GetUserName(&user_name[0],&size) ;
		user_name = tstring(user_name.c_str()) ;
		}
	#endif
	if (user_name.empty()) {
		#define	E_Usr1		_T("USER")
		#define	E_Usr2		_T("USERNAME")
		if (user_name.empty())	{	user_name = ::TGetEnv(E_Usr1) ;		}
		if (user_name.empty())	{	user_name = ::TGetEnv(E_Usr2) ;		}
		}
	return	user_name.c_str() ;
	}

