//	*******************************************************************************
//	Name	:	vol_info.hxx
//			:	get volume info
//	Author	:	I. Nakagawa
//	Create	:	2021/07/02
//	*******************************************************************************

#pragma		once

#include	<Windows.h>

#include	"i_define.hxx"
#include	"filepath.hxx"

////
//	*******************************************************************************
//	volume infomation
//	Create	:	2021/07/02
//	*******************************************************************************
class	VolumeInfo	{
public:
	VolumeInfo			()					{	Serial = MaxLength = FS_Flags = 0 ;		}
public:
	tstring	VolumeName ;
	u_32	Serial ;
	u_32	MaxLength ;
	u_32	FS_Flags ;
	tstring	FS_Name ;
	} ;

////
//	*******************************************************************************
//	volume infomation
//	Create	:	2021/07/02
//	*******************************************************************************
inline	VolumeInfo	GetVolumeInfo	(LPCTSTR path)
{
	VolumeInfo	vi ;
	{
		tstring	root = ::Path_Get_net_root(path) ;
				root = ::Path_AddLastSP   (root) ;
		tstring	vn ;			vn.resize(1024) ;
		DWORD	sn = 0 ;
		DWORD	cl = 0 ;
		DWORD	ff = 0 ;
		tstring	fn ;			fn.resize(1024) ;
		if (::GetVolumeInformation(root.c_str(),&vn[0],1024,&sn,&cl,&ff,&fn[0],1024)) {
			vi.VolumeName	= vn.c_str() ;
			vi.Serial		= sn ;
			vi.MaxLength	= cl ;
			vi.FS_Flags		= ff ;
			vi.FS_Name		= fn.c_str() ;
			}
		}
	return	vi ;
	}

