//	*******************************************************************************
//	Name	:	SH_IDL.hxx
//			:	ITEMIDLIST Functions
//	Author	:	I. Nakagawa
//	Create	:	2021/06/11
//	Modify	:	2021/06/11
//	*******************************************************************************

#pragma		once

#include	<ShlObj.h>
#include	"tstring.hxx"

////
//	*******************************************************************************
//	get path
//	Create	:	2021/06/11
//	*******************************************************************************
inline	tstring	SH_GetPathFromIDList	(LPCITEMIDLIST pidl)
{
	tstring	path ;
	path.resize(MAX_PATH+10) ;
	BOOL	result = ::SHGetPathFromIDList(pidl,&path[0]) ;
	return	path.c_str() ;
	}


#ifdef	__________________________________________________________
//**************************************************************************************************
//	t@C	FHelpSH_.hxx
//	@\		FSH` ȗ
//	쐬		F
//	쐬N	FfOV^OT^PU
//	ύX	FfOV^OT^QS	SH__GetFolderPath  CSIDL ݂̂̊֐ǉ
//				FfOX^OV^PT	ITEMIDLIST		t@CpX	̒ǉ
//**************************************************************************************************

#ifndef	_INC_H_HELP_SH__API
#define	_INC_H_HELP_SH__API

#include	<Afx.h>
#include	<ShlObj.h>
#include	"CRT_MBWC.hxx"

#ifndef	CSIDL_FLAG_CREATE
#define CSIDL_FLAG_CREATE               0x8000        // combine with CSIDL_ value to force folder creation in SHGetFolderPath()
#endif

////
//*******************************************************************************
//	֐	FCSIDL ltH_pX̎擾
//	쐬	FfOV^OT^PU
//*******************************************************************************
inline	CString	SH__GetFolderPath(HWND hwnd, int csidl, HANDLE hToken, DWORD dwFlags)
{
	CString		path ;	
	LPTSTR		pPath = path.GetBuffer(MAX_PATH*2+10) ;
	ZeroMemory (pPath,MAX_PATH*2+10) ;
	#if(_MFC_VER >= 0x0700)
		HRESULT		hr =	::SHGetFolderPath					(hwnd,csidl,hToken,dwFlags,pPath) ;
	#else
	{
		HMODULE	hDll = LoadLibrary	(_T("Shell32.dll")) ;
		BOOL	noSHGet_ = TRUE ;
		if (hDll != NULL)	{
			BOOL	(WINAPI* pSHGetSpecialFolderPath)(HWND,LPTSTR,int,BOOL) = NULL ;
			#ifdef	_UNICODE
				(FARPROC&)pSHGetSpecialFolderPath = ::GetProcAddress(hDll,"SHGetSpecialFolderPathW") ;
			#else
				(FARPROC&)pSHGetSpecialFolderPath = ::GetProcAddress(hDll,"SHGetSpecialFolderPathA") ;
			#endif
			if (pSHGetSpecialFolderPath != NULL) {	//	SHGetSpecialFolderPath T|[gĂ
				BOOL		fCreate = csidl&CSIDL_FLAG_CREATE ;
				HRESULT		hr = 	pSHGetSpecialFolderPath		(hwnd,pPath,csidl,fCreate) ;
			//	int			csidl_	= csidl&(~CSIDL_FLAG_MASK) ;
			//	HRESULT		hr = 	::SHGetSpecialFolderPath	(hwnd,pPath,csidl_,fCreate) ;
				noSHGet_ = FALSE ;
				}
			}
		if (noSHGet_) {	//	Win95  IE4 ĂȂȂ
			LPITEMIDLIST	pidl = NULL ;
			IMalloc*	pMalloc = NULL ;
			SHGetMalloc(&pMalloc) ;
			HRESULT		hr =	::SHGetSpecialFolderLocation	(hwnd,csidl,&pidl) ;
			BOOL	result =	::SHGetPathFromIDList			(pidl,pPath) ;
			pMalloc->Free(pidl) ;
			pMalloc->Release() ;
			}
		}
	#endif
	path.ReleaseBuffer() ;
	return	path ;
	}
inline	CString	SH__GetFolderPath(int csidl)	{	return	SH__GetFolderPath(NULL,csidl,NULL,0) ;	}

////
//*******************************************************************************
//	֐	Ft@CpX		ITEMIDLIST
//	쐬	FfOV^OT^PU
//*******************************************************************************
//	KB132750	,	SHSimpleIDListFromPath
//	http://www.kab-studio.biz/Programing/Codian/ShellExtension/03.html
inline
LPITEMIDLIST	SH__GetIDListFromPath	(LPCTSTR path)
{
	if (_tcslen(path) == 0)									{	return	NULL ;	}

	//	Get a pointer to the Desktop's IShellFolder interface.
	LPSHELLFOLDER	pDesktopFolder ;
	if (::SHGetDesktopFolder(&pDesktopFolder) != NOERROR)	{	return	NULL ;	}

	//	IShellFolder::ParseDisplayName requires the file name be in Unicode.
	OLECHAR			olePath[MAX_PATH] ;
	#ifdef	_UNICODE
	::TcsCpy(olePath,MAX_PATH,path) ;
	#else
	::MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,path,-1,olePath,MAX_PATH) ;
	#endif

	//	Convert the path to an ITEMIDLIST.
	LPITEMIDLIST	pidl		= NULL ;
	ULONG			chEaten		= 0 ;
	ULONG			dwAttributes= 0 ;
//	HRESULT	hr = pDesktopFolder->lpVtbl->ParseDisplayName(pDesktopFolder,
//						NULL,NULL,olePath,
//						&chEaten,&pidl,&dwAttributes) ;
	HRESULT	hr = pDesktopFolder->ParseDisplayName(
						NULL,NULL,olePath,
						&chEaten,&pidl,&dwAttributes) ;
	if (hr != NOERROR)	{	pidl = NULL ;	}

	//release the desktop folder object
//	pDesktopFolder->lpVtbl->Release() ;
	pDesktopFolder->Release() ;

	return	pidl ;
	}

////
//*******************************************************************************
//	֐	FITEMIDLIST		t@CpX
//	쐬	FfOX^OV^PT
//*******************************************************************************
inline
CString		SH__GetPathFromIDList(LPCITEMIDLIST pidl)
{
	CString		path ;
	TCHAR*		pPath = path.GetBuffer(MAX_PATH*2+10) ;
	memset(pPath,0,MAX_PATH*2+10) ;
	BOOL		result = ::SHGetPathFromIDList(pidl,pPath) ;
	path.ReleaseBuffer() ;
	return	path ;
	}

////
//*******************************************************************************
//	֐	FpX\̎擾
//	쐬	FfOV^OT^PU
//*******************************************************************************
inline	CString	SH__GetDisplayName(LPCITEMIDLIST pidl/*,DWORD uFlags*/)
{
	CString	dispName ;
	{
		SHFILEINFO	sfi ;	ZeroMemory(&sfi,sizeof(sfi)) ;
		UINT		flag = SHGFI_DISPLAYNAME | SHGFI_PIDL ;
		SHGetFileInfo((LPCTSTR)pidl,0,&sfi,sizeof(SHFILEINFO),flag) ;
		dispName = sfi.szDisplayName ;
		}
	return	dispName ;
/*
	IShellFolder*	lpsfDTF = NULL ;
	HRESULT	hr = ::SHGetDesktopFolder(&lpsfDTF) ;
	if (FAILED(hr))				{	return	dispName ;	}
	if (lpsfDTF == NULL)		{	return	dispName ;	}
	STRRET		strr ;
	lpsfDTF->GetDisplayNameOf(pidl,SHGDN_NORMAL,&strr) ;
//	#ifndef	StrRetToBuf
	{
		char*	pDisp = dispName.GetBuffer(MAX_PATH) ;
		memset(pDisp,0,MAX_PATH) ;
		switch	(strr.uType)	{
			case	STRRET_CSTR :	strcpy(pDisp,(LPSTR)strr.cStr) ;											break ;
			case	STRRET_OFFSET :	strcpy(pDisp,(LPSTR)pidl+strr.uOffset) ;									break ;
			case	STRRET_WSTR :	WideCharToMultiByte(CP_ACP,0,strr.pOleStr,-1,pDisp,MAX_PATH,NULL,NULL) ;	break ;
		//	case	STRRET_WSTR :	WideCharToMultiByte(CP_THREAD_ACP,0,strr.pOleStr,-1,pDisp,MAX_PATH,NULL,NULL) ;
			default :																							break ;
			}
		dispName.ReleaseBuffer() ;
		}
	#else
	{
		TCHAR*	pDisp = dispName.GetBuffer(MAX_PATH) ;
		memset(pDisp,0,MAX_PATH) ;
		StrRetToBuf(&strr,pidl,pDisp,MAX_PATH) ;
		dispName.ReleaseBuffer() ;
		}
	#endif
*/
	return	dispName ;
	}
inline	CString	SH__GetDisplayName(LPCTSTR path)
{
/*
	LPITEMIDLIST	pidl = SH__GetIDListFromPath(path) ;
	CString			name = SH__GetDisplayName(pidl) ;
	afxDump << path << "\t\t" << name << "\r\n" ;
*/
	CString	name ;
	if (!CString(path).IsEmpty()) {
		SHFILEINFO	sfi ;	ZeroMemory(&sfi,sizeof(sfi)) ;
		UINT		flag = SHGFI_DISPLAYNAME ;
		SHGetFileInfo(path,0,&sfi,sizeof(SHFILEINFO),flag) ;
		name = sfi.szDisplayName ;
		}
	return	name ;
	}


////////////////////////////////////////////////////////////////////////////////////////////////////
//	ǉꂽ CSIDL
////////////////////////////////////////////////////////////////////////////////////////////////////
//	(VS8)\VC\PlatformSDK\Include\ShlObj.h
#ifndef	CSIDL_MYDOCUMENTS
#define CSIDL_MYDOCUMENTS				0x000c        // logical "My Documents" desktop icon
#endif
#ifndef	CSIDL_MYMUSIC
#define CSIDL_MYMUSIC					0x000d        // "My Music" folder
#endif
#ifndef	CSIDL_MYVIDEO
#define CSIDL_MYVIDEO					0x000e        // "My Videos" folder
#endif
#ifndef	CSIDL_0x000f
#define	CSIDL_0x000f					0x000f
#endif
#ifndef CSIDL_LOCAL_APPDATA
#define CSIDL_LOCAL_APPDATA				0x001c        // <user name>\Local Settings\Applicaiton Data (non roaming)
#endif
#ifndef	CSIDL_COMMON_APPDATA
#define CSIDL_COMMON_APPDATA            0x0023        // All Users\Application Data
#endif
#ifndef	CSIDL_WINDOWS
#define CSIDL_WINDOWS                   0x0024        // GetWindowsDirectory()
#endif
#ifndef	CSIDL_SYSTEM
#define CSIDL_SYSTEM                    0x0025        // GetSystemDirectory()
#endif
#ifndef	CSIDL_PROGRAM_FILES
#define CSIDL_PROGRAM_FILES             0x0026        // C:\Program Files
#endif
#ifndef	CSIDL_MYPICTURES
#define CSIDL_MYPICTURES                0x0027        // C:\Program Files\My Pictures
#endif
#ifndef	CSIDL_PROFILE
#define CSIDL_PROFILE                   0x0028        // USERPROFILE
#endif
#ifndef	CSIDL_SYSTEMX86
#define CSIDL_SYSTEMX86                 0x0029        // x86 system directory on RISC
#endif
#ifndef	CSIDL_PROGRAM_FILESX86
#define CSIDL_PROGRAM_FILESX86          0x002a        // x86 C:\Program Files on RISC
#endif
#ifndef	CSIDL_PROGRAM_FILES_COMMON
#define CSIDL_PROGRAM_FILES_COMMON      0x002b        // C:\Program Files\Common
#endif
#ifndef	CSIDL_PROGRAM_FILES_COMMONX86
#define CSIDL_PROGRAM_FILES_COMMONX86   0x002c        // x86 Program Files\Common on RISC
#endif
#ifndef	CSIDL_COMMON_TEMPLATES
#define CSIDL_COMMON_TEMPLATES          0x002d        // All Users\Templates
#endif
#ifndef	CSIDL_COMMON_DOCUMENTS
#define CSIDL_COMMON_DOCUMENTS          0x002e        // All Users\Documents
#endif
#ifndef	CSIDL_COMMON_ADMINTOOLS
#define CSIDL_COMMON_ADMINTOOLS         0x002f        // All Users\Start Menu\Programs\Administrative Tools
#endif
#ifndef	CSIDL_ADMINTOOLS
#define CSIDL_ADMINTOOLS                0x0030        // <user name>\Start Menu\Programs\Administrative Tools
#endif
#ifndef	CSIDL_CONNECTIONS
#define CSIDL_CONNECTIONS               0x0031        // Network and Dial-up Connections
#endif
#ifndef	CSIDL_0x0032
#define	CSIDL_0x0032					0x0032
#endif
#ifndef	CSIDL_0x0033
#define	CSIDL_0x0033					0x0033
#endif
#ifndef	CSIDL_0x0034
#define	CSIDL_0x0034					0x0034
#endif
#ifndef	CSIDL_COMMON_MUSIC
#define CSIDL_COMMON_MUSIC              0x0035        // All Users\My Music
#endif
#ifndef	CSIDL_COMMON_PICTURES
#define CSIDL_COMMON_PICTURES           0x0036        // All Users\My Pictures
#endif
#ifndef	CSIDL_COMMON_VIDEO
#define CSIDL_COMMON_VIDEO              0x0037        // All Users\My Video
#endif
#ifndef	CSIDL_RESOURCES
#define CSIDL_RESOURCES                 0x0038        // Resource Direcotry
#endif
#ifndef	CSIDL_RESOURCES_LOCALIZED
#define CSIDL_RESOURCES_LOCALIZED       0x0039        // Localized Resource Direcotry
#endif
#ifndef	CSIDL_COMMON_OEM_LINKS
#define CSIDL_COMMON_OEM_LINKS          0x003a        // Links to All Users OEM specific apps
#endif
#ifndef	CSIDL_CDBURN_AREA
#define CSIDL_CDBURN_AREA               0x003b        // USERPROFILE\Local Settings\Application Data\Microsoft\CD Burning
#endif
#ifndef	CSIDL_0x003c
#define	CSIDL_0x003c					0x003c
#endif
#ifndef	CSIDL_COMPUTERSNEARME
#define CSIDL_COMPUTERSNEARME           0x003d        // Computers Near Me (computered from Workgroup membership)
#endif
#ifndef	CSIDL_0x003e
#define	CSIDL_0x003e					0x003e
#endif
#ifndef	CSIDL_PLAYLISTS
#define	CSIDL_PLAYLISTS					0x003f
#endif
#ifndef	CSIDL_SAMPLE_MUSIC
#define	CSIDL_SAMPLE_MUSIC				0x0040
#endif
#ifndef	CSIDL_SAMPLE_PLAYLISTS
#define	CSIDL_SAMPLE_PLAYLISTS			0x0041
#endif
#ifndef	CSIDL_SAMPLE_PICTURES
#define	CSIDL_SAMPLE_PICTURES			0x0042
#endif
#ifndef	CSIDL_SAMPLE_VIDEOS
#define	CSIDL_SAMPLE_VIDEOS				0x0043
#endif
#ifndef	CSIDL_0x0044
#define	CSIDL_0x0044					0x0044
#endif
#ifndef	CSIDL_PHOTOALBUMS
#define	CSIDL_PHOTOALBUMS				0x0045
#endif
#ifndef	CSIDL_0x0046
#define	CSIDL_0x0046					0x0046
#endif
#ifndef	CSIDL_0x0047
#define	CSIDL_0x0047					0x0047
#endif
#ifndef	CSIDL_0x0048
#define	CSIDL_0x0048					0x0048
#endif
#ifndef	CSIDL_0x0049
#define	CSIDL_0x0049					0x0049
#endif
#ifndef	CSIDL_0x004a
#define	CSIDL_0x004a					0x004a
#endif
#ifndef	CSIDL_0x004b
#define	CSIDL_0x004b					0x004b
#endif
#ifndef	CSIDL_0x004c
#define	CSIDL_0x004c					0x004c
#endif
#ifndef	CSIDL_0x004d
#define	CSIDL_0x004d					0x004d
#endif
#ifndef	CSIDL_0x004e
#define	CSIDL_0x004e					0x004e
#endif
#ifndef	CSIDL_0x004f
#define	CSIDL_0x004f					0x004f
#endif

#ifndef	CSIDL_FLAG_CREATE
#define CSIDL_FLAG_CREATE               0x8000        // combine with CSIDL_ value to force folder creation in SHGetFolderPath()
#endif
#ifndef	CSIDL_FLAG_MASK
#define CSIDL_FLAG_MASK                 0xFF00        // mask for all possible flag values
#endif

#endif


#endif	//	_____________________________________________________________
