//	*******************************************************************************
//	Name	:	existff.hxx
//			:	String File Functions
//	Author	:	I. Nakagawa
//	Create	:	2013/08/30
//	Modify	:	2014/08/21		Change this file name
//	Modify	:	2024/03/04		add ::Path_Normalize
//	*******************************************************************************

#pragma		once

#ifdef		_MSC_VER
#include	<io.h>
#endif

#include	"strpath.hxx"
#include	"filestat.hxx"

////
//	*******************************************************************************
//	Check Folder
//	Create	:	2013/08/30
//	Modify	:	2024/03/04	add ::Path_Normalize
//	*******************************************************************************
inline	bool	Folder_IsExist(LPCTSTR folder_name)
{
	tstring	fold_name = ::Path_DelLastSP(folder_name) ;
	#ifdef	_MSC_VER
	if (::String__Find(fold_name,Path_SP_GNU) != tstring::npos) {
		fold_name = ::Path_Normalize(fold_name) ;
		}
	if (fold_name.substr(0,2) == _T("\\\\")) {
		bool	isExist = (_taccess(fold_name.c_str(),0)==0) ;
		return	isExist ;
		}
	#endif
	F_Stat	fs(fold_name.c_str()) ;
	if (fs.IsError())		{	return	false ;	}
	if (fs.IsDirectory())	{	return	true ;	}
	return	false ;
	}

////
//	*******************************************************************************
//	Check File
//	Create	:	2013/08/30
//	Modify	:	2024/03/04	add ::Path_Normalize
//	*******************************************************************************
inline	bool	File_IsExist(LPCTSTR file_path,const bool needSize=false)
{
	tstring	file_name = file_path ;
	#ifdef	_MSC_VER
	if (::String__Find(file_name,Path_SP_GNU) != tstring::npos) {
		file_name = ::Path_Normalize(file_name) ;
		}
	if (file_name.substr(0,2) == _T("\\\\")) {
		bool	isExist = (_taccess(file_name.c_str(),0)==0) ;
		return	isExist ;
		}
	#endif
	F_Stat	fs(file_name.c_str()) ;
	if (fs.IsError())		{	return	false ;	}
	if (fs.GetSize() > 0)	{	return	true ;	}
	if (fs.IsDirectory())	{	return	true ;	}
	if (!needSize)			{	return	true ;	}
	return	false ;
	}

////
//	*******************************************************************************
//	Check File , Folder
//	Create	:	2013/08/30
//	*******************************************************************************
inline	bool	Folder_IsNothing	(LPCTSTR foldName)	{	return	!(::Folder_IsExist(foldName)) ;	}
inline	bool	  File_IsNothing	(LPCTSTR fileName)	{	return	!(::  File_IsExist(fileName)) ;	}

inline	bool	Folder_IsExist		(c_tstring& foldName)						{	return	::Folder_IsExist	(foldName.c_str()) ;	}
inline	bool	  File_IsExist		(c_tstring& filePath,const bool ns=false)	{	return	::	File_IsExist	(filePath.c_str(),ns) ;	}
inline	bool	Folder_IsNothing	(c_tstring& foldName)						{	return	::Folder_IsNothing	(foldName.c_str()) ;	}
inline	bool	  File_IsNothing	(c_tstring& fileName)						{	return	::  File_IsNothing	(fileName.c_str()) ;	}

