//	*******************************************************************************
//	Name	:	FileAttr.hxx
//			:	Win File Attribuge
//	Author	:	I. Nakagawa
//	Create	:	2013/10/21
//	Modify	:	2015/10/30		move ClearForWrite
//	*******************************************************************************

#pragma		once

#include	<Windows.h>

#include	"strpath.hxx"

////
//	*******************************************************************************
//	File Attribute
//	Create	:	2013/10/21
//	Modify	:	2015/10/30		move ClearForWrite
//	*******************************************************************************
class	F_Attribute	{
public:
					F_Attribute		(c_tstring fileName_)	{
										tstring	fileName = fileName_ ;
												fileName = ::Path_Normalize(fileName) ;
												fileName = ::Path_DelLastSP(fileName) ;
										Attributes = ::GetFileAttributes(fileName.c_str()) ;
										if (Attributes != -1)	{
											FileName = fileName ;
											}
										}
public:
	virtual	BOOL	IsError			(void)	const	{	return	(Attributes==-1) ;	}
	virtual	DWORD	GetAttribute	(void)	const	{	return	Attributes ;		}
protected:
	virtual	tstring	GetFileName		(void)	const	{	return	FileName ;			}
public:
	virtual	BOOL	Is___Flag		(const DWORD flag)	{	return										 Attributes&  flag ;	}
	virtual	BOOL	ClearFlag		(const DWORD flag)	{	return	::SetFileAttributes(FileName.c_str(),Attributes&(~flag)) ;	}
	virtual	BOOL	Set__Flag		(const DWORD flag)	{	return	::SetFileAttributes(FileName.c_str(),Attributes|( flag)) ;	}
public:
	virtual	BOOL	ClearForWrite	(void)	{	return	Clear_Flag(FILE_ATTRIBUTE_READONLY
																|  FILE_ATTRIBUTE_HIDDEN
																|  FILE_ATTRIBUTE_SYSTEM) ;		}
protected:
	virtual	BOOL	Clear_Flag		(const DWORD flag)	{
										if (Is___Flag(flag))	{	return	ClearFlag(flag) ;	}
										return	TRUE ;
										}
protected:
	tstring	FileName ;
	DWORD	Attributes ;
	} ;

inline	BOOL	FA_Is_ReadOnly	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Is___Flag(FILE_ATTRIBUTE_READONLY) ;	}
inline	BOOL	FA_ClrReadOnly	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.ClearFlag(FILE_ATTRIBUTE_READONLY) ;	}
inline	BOOL	FA_SetReadOnly	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Set__Flag(FILE_ATTRIBUTE_READONLY) ;	}
inline	BOOL	FA_Is_Hidden	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Is___Flag(FILE_ATTRIBUTE_HIDDEN) ;	}
inline	BOOL	FA_ClrHidden	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.ClearFlag(FILE_ATTRIBUTE_HIDDEN) ;	}
inline	BOOL	FA_SetHidden	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Set__Flag(FILE_ATTRIBUTE_HIDDEN) ;	}
inline	BOOL	FA_Is_System	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Is___Flag(FILE_ATTRIBUTE_SYSTEM) ;	}
inline	BOOL	FA_ClrSystem	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.ClearFlag(FILE_ATTRIBUTE_SYSTEM) ;	}
inline	BOOL	FA_SetSystem	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Set__Flag(FILE_ATTRIBUTE_SYSTEM) ;	}
inline	BOOL	FA_Is_Directory	(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.Is___Flag(FILE_ATTRIBUTE_DIRECTORY);	}
inline	BOOL	FA_ClearForWrite(c_tstring& file)	{	F_Attribute	fa(file) ;	return	fa.ClearForWrite() ;					}

////
//	*******************************************************************************
//	Undo File Attribute
//	Create	:	2013/10/21
//	*******************************************************************************
class	UndoAttribute	:	public	F_Attribute	{
public:
					UndoAttribute	(c_tstring fileName)	:	F_Attribute(fileName)	{
									}
	virtual			~UndoAttribute	()	{
									F_Attribute	fa(GetFileName()) ;
									DWORD	orgAttr = this->GetAttribute() ;
									DWORD	nowAttr = fa.	GetAttribute() ;
									if (orgAttr != nowAttr)	{	Set__Flag(orgAttr) ;	}
									}
public:
	virtual	BOOL	ClearReadOnly	(void)	{	return	Clear_Flag(FILE_ATTRIBUTE_READONLY) ;	}
	virtual	BOOL	ClearHidden		(void)	{	return	Clear_Flag(FILE_ATTRIBUTE_HIDDEN) ;		}
	virtual	BOOL	ClearSystem		(void)	{	return	Clear_Flag(FILE_ATTRIBUTE_SYSTEM) ;		}
	} ;

