//	*******************************************************************************
//	Name	:	i_trace.hxx
//			:	Debug Functions
//	Author	:	I. Nakagawa
//	Create	:	2016/04/22
//	Modify	:	2016/10/19
//	Modify	:	2019/12/27
//	*******************************************************************************

#pragma		once

#include	"t_v_char.hxx"
#include	"createff.hxx"
#include	"timefmt.hxx"
#include	"get_path.hxx"
#include	"openfile.hxx"
#include	"filefnc.hxx"
#include	"username.hxx"

#ifdef		_WIN32
#include	"i_SH_Get.hxx"
//#include	"HelpWAPI.hxx"
#endif

////
//	*******************************************************************************
//	Trace
//	Create	:	2016/04/22
//	Modify	:	2016/10/18
//	Modify	:	2019/12/27
//	*******************************************************************************
inline	bool	i_Trace	(const v_char text)
{
	tstring	pathName ;
	{
		static	bool	ClearYet = true ;
		tstring	md_HStr = ::Now_Format(_T("%m%d_%H")) ;
		#ifdef	_DEBUG
				md_HStr = ::Now_Format(_T("%d_%H%M")) ;
		#endif
		{
			pathName = ::GetTmpPath() ;
			#ifdef	CSIDL_COMMON_DOCUMENTS
			pathName = ::SH_GetFolderPath(CSIDL_COMMON_DOCUMENTS) ;
			pathName = ::Path_AddLastSP(pathName) + _T("Temp") ;
			pathName = ::Path_AddLastSP(pathName) + _T("Temp") ;
			#endif
			pathName = ::Path_AddLastSP(pathName) + _T("DbgDump") ;
			pathName = ::Path_AddLastSP(pathName) ;
			if (ClearYet)	{	::Remove_File_later(pathName+_T(".txt")) ;	}
			#if		defined	_UNICODE
			pathName = ::Path_AddLastSP(pathName) + _T("WC") ;
			#elif	defined	_MBCS
			pathName = ::Path_AddLastSP(pathName) + _T("MB") ;
			#endif
			::Folder_Create(pathName) ;
			pathName = ::Path_AddLastSP(pathName) ;
			if (ClearYet)	{	::Remove_File_later(pathName+_T(".txt")) ;	}
			pathName = ::Path_AddLastSP(pathName) + md_HStr + _T(".txt") ;
			}
		ClearYet = false ;
		}
	FILE*	ofp = ::Open_File(pathName.c_str(),_T("ab")) ;
	if (ofp == NULL)	{
	//	::Log_Message((tstring(_T("Can't open ab  "))+pathName).c_str()) ;
		tstring	msg = 		   _T("Can't open ab  ") +pathName ;
		#ifdef	_DEBUG
			#ifdef	_MFC_VER
				afxDump		<< msg.c_str() << _T("\r\n") ;
			#else
				std::terr	<< msg         << std::endl ;
			#endif
		#endif
		return	false ;
		}
	{
		size_t	fSize = size_t(F_Stat::GetSize(pathName.c_str())) ;
		if (fSize == 0) {
			#ifdef	_UNICODE
			{
				#define	UTF16_BOM	("\xff\xfe")
				v_char	bom = ::To_v_char(UTF16_BOM) ;
				::fwrite(&bom[0],sizeof(char),bom.size(),ofp) ;
				}
			#endif
			#ifdef	_WIN32
			{
			//	::MessageBeep(-1) ;
				}
			#endif
			#ifdef	_WIN32
			{
			//	tstring	userName = ::i_GetUserName()			+	_T("\r\n") ;
				tstring	userName = ::Get_user_name()			+	_T("\r\n") ;
			//	tstring	temp_Dir = ::i_GetTempPath()			+	_T("\r\n") ;
				tstring	temp_Dir = ::GetTmpPath   ()			+	_T("\r\n") ;
			//	tstring	currentD = ::i_GetCurrentDirectory()	+	_T("\r\n") ;
				tstring	currentD = ::GetCWD               ()	+	_T("\r\n") ;
			//	tstring	exe_Name = ::i_GetModuleFileName()		+	_T("\r\n") ;
				tstring	exe_Name = ::Get_module_name    ()		+	_T("\r\n") ;
				tstring	writeStr = userName + temp_Dir + currentD + exe_Name ;
				tstring	tStr = ::String_CrLfToSP(writeStr,_T("\t\t")) ;
						tStr = ::Now_Format() + _T("\t") + tStr + _T("\r\n") ;
				v_char	v_chr = ::To_v_char(tStr) ;
				::fwrite(&v_chr[0],sizeof(char),v_chr.size(),ofp) ;
				}
			#endif
			}
		}
	if (text.size() > 0) {
		::fwrite(&text[0],sizeof(char),text.size(),ofp) ;
		}
	::fclose(ofp) ;
	return	true ;
	}

////
//	*******************************************************************************
//	Trace	tstring
//	Create	:	2016/04/22
//	Modify	:	2016/10/19	use String_CrLfToSP
//	*******************************************************************************
inline	bool	i_Trace	(const tstring& tStr_)
{
//	tstring	tStr = tStr_ ;
	tstring	tStr = ::String_CrLfToSP(tStr_,_T("\t\t")) ;
	tstring	exe_Name ;
	#ifdef	_WIN32
	//		exe_Name = ::Path_GetName(i_GetModuleFileName())	+	_T("\t") ;
			exe_Name = ::Path_GetName(::Get_module_name())		+	_T("\t") ;
	#endif
//	if (tStr.empty())	{	return	false ;		}
	{
		tStr = ::Now_Format() + _T("\t")	+	exe_Name	+ tStr + _T("\r\n") ;
		}
	v_char	v_chr = ::To_v_char(tStr) ;
	return	::i_Trace(v_chr) ;
	}

