//	*******************************************************************************
//	Name	:	WNet_fnc.hxx
//			:	WNet... functions
//	Author	:	I. Nakagawa
//	Create	:	2020/11/18
//	Modify	:	2020/11/18
//	*******************************************************************************

#pragma		once

#include	"i_def_aw.hxx"
#include	"i_define.hxx"
#include	"tstring.hxx"

//#include	<winnetwk.h>
#pragma		comment	(lib,"mpr.lib")

////
//	*******************************************************************************
//	get remote name
//	A:\			->	\\AS5202T\Home\
//	B:\abc.txt	->	\\AS5202T\Public\abc.txt
//	Create	:	2020/11/18
//	*******************************************************************************
inline	tstring	W_get_remote_name	(LPCTSTR path_)
{
	tstring	dpath = path_ ;
	if (dpath.size() < 2)		{	return	dpath ;		}
	tstring	drive = dpath.substr(0,2) ;
	tstring	_path = dpath.substr(2) ;
	tstring	remote_path ;
	if (drive.length() == 2) {
		if (drive[1] == _T(':')) {
			u_16	d_t  = ::GetDriveType(drive.c_str()) ;
			if (d_t == DRIVE_REMOTE) {
				DWORD	buf_size = MAX_PATH ;
				tstring	remote_name ;
				remote_name.resize(buf_size+1) ;
				::WNetGetConnection(drive.c_str(),&remote_name[0],&buf_size) ;
				remote_path = remote_name.c_str() ;
				if (!remote_path.empty()) {
					remote_path = remote_path + _path ;
					}
				}
			}
		}
	if (remote_path.empty())	{	return	dpath ;		}
	return	remote_path ;
	}

