//	*******************************************************************************
//	Name	:	itls_tmp.hxx
//			:	%TEMP%/i_Tools.tmp/exe_title/
//	Author	:	I. Nakagawa
//	Create	:	2016/06/16
//	Modify	:	2016/06/30	Add "Clear_..."
//	Modify	:	2018/02/28	Add "Get_convert_..."
//	Modify	:	2021/07/06	::Get_module_name
//	Modify	:	2022/08/05	::Get_Self_Original
//	Modify	:	2022/08/05	::Get_i_Tools_tmp_name
//	Modify	:	2024/04/17	"24 04 17"
//	*******************************************************************************

#pragma		once

#include	"i_trace.hxx"
#include	"get_path.hxx"
#include	"createff.hxx"
#include	"delff_e.hxx"
#include	"log_msg.hxx"
#include	"timefmt.hxx"

#ifdef	_WIN32
#include	"FVersion.hxx"
#include	"i_SH_Get.hxx"
#endif

#ifdef	_DEBUG
	#define	ITT_YMD	_T("%y %m %d")	//	"24 04 17"
#else
	#define	ITT_YMD	_T("%Y%m%d")	//	"20240417"
#endif

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/name/...
//	Create	:	2022/08/05
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_name		(LPCTSTR name)
{
	tstring	tmp_path = ::GetTmpPath() ;
			tmp_path = ::Path_AddLastSP(tmp_path) + _T("i_Tools.tmp") ;
			tmp_path = ::Path_AddLastSP(tmp_path) + name ;
	::Folder_Create(tmp_path) ;
	return	tmp_path ;
	}

inline	tstring	Get_i_Tools_tmp_name_date	(LPCTSTR name)
{
	tstring	tmp_path = ::Get_i_Tools_tmp_name(name) ;
			tmp_path = ::Path_AddLastSP(tmp_path) + ::Now_Format(ITT_YMD) ;
	::Folder_Create(tmp_path) ;
	return	tmp_path ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/
//	Create	:	2016/06/30
//	Modify	:	2017/03/22	support not _WIN32
//	Modify	:	2021/07/06	::Get_module_name
//	Modify	:	2022/08/05	::Get_Self_Original
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_Path	(void)
{
	tstring	exe_title ;
			exe_title = ::Now_Format(ITT_YMD) ;
	{
		tstring	mod_name = ::Get_module_name() ;
		tstring	exe_name = ::Path_GetName(mod_name) ;
		#ifdef	_WIN32
		tstring	org_name = ::Get_Self_Original() ;
		if (!org_name.empty()) {
			if (!::String_CompareNoCase(exe_name,org_name)) {
				exe_name = org_name ;
				}
			}
		#endif
		if (!exe_name.empty()) {
			exe_title = ::Path_GetTitle(exe_name) ;
			}
		}
	tstring	tempPath = ::Path_AddLastSP(::GetTmpPath())	+ _T("i_Tools.tmp") ;
			tempPath = ::Path_AddLastSP(tempPath)		+ exe_title ;
			tempPath = ::Path_AddLastSP(tempPath) ;
	return	tempPath ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/
//	Create	:	2016/06/16
//	Modify	:	2017/03/03
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp	(void)
{
	tstring	tempPath = ::Get_i_Tools_tmp_Path() ;
	if (!::Folder_Create(tempPath)) {
		#ifdef	CSIDL_COMMON_DOCUMENTS
		{
		//	tstring	exe_title = ::Path_GetTitle(::i_GetModuleFileName()) ;
			tstring	exe_title = ::Path_GetTitle(::Get_module_name()) ;
			tempPath = ::SH_GetFolderPath(CSIDL_COMMON_DOCUMENTS) ;
			tempPath = ::Path_AddLastSP(tempPath) + _T("Temp") ;
			tempPath = ::Path_AddLastSP(tempPath) + _T("Temp") ;
			tempPath = ::Path_AddLastSP(tempPath) + _T("i_Tools.tmp") ;
			tempPath = ::Path_AddLastSP(tempPath) + exe_title ;
			::i_Trace(tempPath) ;
			}
		#else
		{
			::i_Trace(_T("can not write.  ")+tempPath) ;
			tempPath = ::GetTmpPath() ;
			::Log_Message(tempPath.c_str()) ;
			}
		#endif
		}
			tempPath = ::Path_AddLastSP(tempPath) ;
	return	tempPath ;
	}

////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/date/
//	Create	:	2017/03/31
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_date	(void)
{
	tstring	dateStr  = ::Now_Format(ITT_YMD) ;
	tstring	tempPath = ::Get_i_Tools_tmp() ;
			tempPath = ::Path_AddLastSP(tempPath) + dateStr ;
	if (!::Folder_Create(tempPath)) {
			tempPath = ::Get_i_Tools_tmp() ;
		}
			tempPath = ::Path_AddLastSP(tempPath) ;
	return	tempPath ;
	}

////
//	*******************************************************************************
//	remove ".../i_Tools.tmp/..." empty folder
//	Create	:	2016/06/30
//	Modify	:	2016/08/01	change DelFF_AE_Add
//	*******************************************************************************
inline	bool	Clear_i_Tools_tmp_EmptyFolder	(void)
{
	tstring	tempPath = ::Get_i_Tools_tmp_Path() ;
	{
		if (::Folder_IsExist(tempPath)) {
			v_tstring	emptyFolders = ::EnumFoldersTree(tempPath.c_str()) ;
			::DelFF_AE_Add(emptyFolders) ;
			::DelFF_AE_Add(tempPath) ;
			}
		}
	return	true ;
	}

////
//	*******************************************************************************
//	get "%TMP%/i_Tools.tmp/convert/ext/yymmdd/hhmmss/"
//	Create	:	2019/02/27
//	Modify	:	2019/03/01	add call "::Clear_i_Tools_tmp_EmptyFolder()"
//	*******************************************************************************
inline	tstring	Get_convert_tmp	(LPCTSTR saveName=_T(""))
{
	static	bool	Call_1st = true ;
	if (Call_1st) {
		#ifdef	_OPENMP
			#pragma	omp	critical	(Get_convert_tmp)
		#endif
		{
			if (Call_1st) {
			//	::Clear_i_Tools_tmp_EmptyFolder() ;
				tstring	tempPath = ::Get_i_Tools_tmp_Path() ;
				{
					tempPath = ::Path_DelLastSP (tempPath) ;	//	%Temp%/i_Tools.tmp/exe_name
					tempPath = ::Path_GetDir    (tempPath) ;	//	%Temp%/i_Tools.tmp/
					if (::Folder_IsExist(tempPath)) {
						v_tstring	emptyFolders = ::EnumFoldersTree(tempPath.c_str()) ;
						::DelFF_AE_Add(emptyFolders) ;
						::DelFF_AE_Add(tempPath) ;
						}
					}
				}
			Call_1st = false ;
			}
		}
	tstring	ext = ::Path_GetExtLow(saveName) ;
	tstring	timFmt = _T("%y%m%d/%H%M%S") ;
	tstring	out_tmp ;
	out_tmp = ::Get_i_Tools_tmp() ;
	out_tmp = ::Path_DelLastSP (out_tmp) ;	//	%Temp%/i_Tools.tmp/exe_name
	out_tmp = ::Path_GetDir    (out_tmp) ;	//	%Temp%/i_Tools.tmp/
	out_tmp = ::Path_AddLastSP (out_tmp) +	_T("convert/") + ext ;
	out_tmp = ::Path_AddLastSP (out_tmp) +	::Now_Format(timFmt.c_str()) ;
	out_tmp = ::Path_Normalize (out_tmp) ;
	out_tmp = ::Get_unique_name(out_tmp) ;
	::Folder_Create(out_tmp) ;
	return	out_tmp ;
	}

/*
//#include	"HelpWAPI.hxx"
////
//	*******************************************************************************
//	%TEMP%/i_Tools.tmp/exe_title/
//	Create	:	2016/06/30
//	Modify	:	2017/03/22	support not _WIN32
//	*******************************************************************************
inline	tstring	Get_i_Tools_tmp_Path_2020	(void)
{
	tstring	exe_title ;
#ifdef	_WIN32
			exe_title = ::Path_GetTitle(::i_GetModuleFileName()) ;
#else
			exe_title = ::Now_Format(_T("%Y%m%d")) ;
#endif
	tstring	tempPath = ::Path_AddLastSP(::GetTmpPath())	+ _T("i_Tools.tmp") ;
			tempPath = ::Path_AddLastSP(tempPath)		+ exe_title ;
			tempPath = ::Path_AddLastSP(tempPath) ;
	return	tempPath ;
	}
*/
