//	*******************************************************************************
//	Name	:	tstrutf8.hxx
//			:	tstring convert
//	Author	:	I. Nakagawa
//	Create	:	2014/03/20
//	Modify	:	2014/03/20
//	Modify	:	2017/06/02	DS115j php ... NOP
//	*******************************************************************************

#pragma		once

#include	"tstrmbwc.hxx"
#ifdef		_MSC_VER
#include	<Windows.h>
#else
#include	<iconv.h>
#endif

////
//	*******************************************************************************
//	tstring	->	UTF-8
//	Create	:	2014/03/20
//	*******************************************************************************
inline	std::string	ws_To_UTF8	(const wchar_t* wcStr,const int wLen=-1)
{
	std::string	u8Str ;
	#ifdef		_MSC_VER
	{
		size_t	len =	::WideCharToMultiByte(CP_UTF8,0,wcStr,wLen,NULL,0,NULL,NULL) ;
		u8Str.resize(len) ;
		LPSTR	u8P = LPSTR(&u8Str[0]) ;
				len = 	::WideCharToMultiByte(CP_UTF8,0,wcStr,wLen,u8P,int(len),NULL,NULL) ;
		if (wLen < 0) {
			if (u8Str[u8Str.size()-1] == '\0') {
				len-- ;
				u8Str.resize(len) ;
				}
			}
		}
//	#elif
//	{
		//	gcc	iconv
//		}
	#else
	{
		u8Str = ::To_tstring(wcStr) ;
		}
	#endif
	return	u8Str ;
	}

////
//	*******************************************************************************
//	tstring	->	UTF-8
//	Create	:	2014/03/20
//	Modify	:	2017/06/02	DS115j php ... NOP
//	*******************************************************************************
inline	std::string	To_UTF8	(LPCTSTR strP)
{
	#ifdef		_MSC_VER
	{
		std::wstring	wcStr = ::To_wstring(strP) ;
		return	ws_To_UTF8(wcStr.c_str()) ;
		}
	#else
	{
		return	tstring(strP) ;
		}
	#endif
	}

////
//	*******************************************************************************
//	UTF-8	->	wstring
//	Create	:	2014/03/20
//	*******************************************************************************
inline	std::wstring	UTF8_To_ws	(LPCSTR utf8,const int len=-1)
{
	std::wstring	wcStr ;
	#ifdef		_MSC_VER
	{
		size_t	wLen =	::MultiByteToWideChar(CP_UTF8,0,utf8,len,NULL,0) ;
		wcStr.resize(wLen) ;
		LPWSTR	wcP = LPWSTR(&wcStr[0]) ;
				wLen =	::MultiByteToWideChar(CP_UTF8,0,utf8,len,wcP,int(wLen)) ;
		}
//	#elif
//	{
		//	gcc	iconv
//		}
	#else
	{
		wcStr = ::To_wstring(utf8) ;
		}
	#endif
	return	wcStr ;
	}

////
//	*******************************************************************************
//	UTF-8	->	tstring
//	Create	:	2014/03/20
//	Modify	:	2017/06/02	DS115j php ... NOP
//	*******************************************************************************
inline	tstring	UTF8_To	(LPCSTR utf8/*,const int len=-1*/)
{
	#ifdef		_MSC_VER
	{
		std::wstring	wcStr = ::UTF8_To_ws(utf8/*,len*/) ;
		return	::To_tstring(wcStr.c_str()) ;
		}
	#else
	{
		return	tstring(utf8) ;
		}
	#endif
	}

////
//	*******************************************************************************
//	UTF-8 (wstring)	->	tstring
//	Create	:	2017/05/30
//	*******************************************************************************
inline	tstring	UTF8_To	(const wchar_t* w_Str)
{
	std::wstring	wcStr = w_Str ;
	std::string		u8Str ;
	for (size_t index=0 ; index<wcStr.length() ; index++) {
		char	c = char(wcStr[index]) ;
		u8Str += c ;
		}
	return	::UTF8_To(u8Str.c_str()) ;
	}

