//	*******************************************************************************
//	Name	:	ask_path.hxx
//			:	ask path
//	Author	:	I. Nakagawa
//	Create	:	2021/07/02
//	Modify	:	2022/05/24	
//	*******************************************************************************

#pragma		once

#ifdef		_WIN32
#include	"vol_info.hxx"
#include	"S_Browse.hxx"
#include	"WFDialog.hxx"
#include	"con_wnd.hxx"
#include	"WNet_fnc.hxx"
#endif
#include	"def_OFN.hxx"
#include	"quotm.hxx"

////
//	*******************************************************************************
//	ask path cli
//	Create	:	2022/05/24
//	*******************************************************************************
inline	tstring	ask_path_cli	(LPCTSTR msg)
{
	tstring	path ;
	while(true)	{
		tstring	buf ;
		buf.resize(1000) ;
		std::terr << msg ;
		std::tin.getline(&buf[0],std::streamsize(buf.size())) ;
		buf = ::QuotM_Del_All(buf.c_str()) ;
		if		(buf == _T("q"))	{	break ;		}
		else if (buf == _T("Q"))	{	break ;		}
		if (buf.empty())			{	continue ;	}
		path = buf.c_str() ;
		break ;
		}
	return	path ;
	}

////
//	*******************************************************************************
//	ask path cli
//	Create	:	2022/05/24
//	*******************************************************************************
inline	tstring	ask_path_cli	(const bool is_fold)
{
	tstring	msg ;
	if (is_fold)	{	msg = _T("folder  =") ;		}
	else			{	msg = _T("file ...=") ;		}
	return	::ask_path_cli(msg.c_str()) ;
	}

////
//	*******************************************************************************
//	ask path
//	Create	:	2021/07/02
//	*******************************************************************************
inline	tstring	ask_path	(const bool is_fold)
{
	tstring	path ;
	while(true)	{
		#ifdef	_WIN32
		{
			HWND	hwnd = ::GetConsoleHwnd() ;
			static	tstring		buf ;
							{	buf = ::W_get_remote_name(  buf.c_str()) ;		}
			if (is_fold)	{	buf = ::Browse_Folder (hwnd,buf.c_str()) ;		}
			else			{	buf = ::FD_GetOpenFile(hwnd,buf.c_str()) ;		}
			if (buf.empty())			{	break ;		}
			path = buf.c_str() ;
			break ;
			}
		#else
		{
			tstring	buf ;
			buf.resize(1000) ;
			tstring	msg ;
			if (is_fold)	{	msg = _T("folder  =") ;		}
			else			{	msg = _T("file ...=") ;		}
			std::terr << msg ;
			std::tin.getline(&buf[0],std::streamsize(buf.size())) ;
			buf = ::QuotM_Del_All(buf.c_str()) ;
			if		(buf == _T("q"))	{	break ;		}
			else if (buf == _T("Q"))	{	break ;		}
			if (buf.empty())			{	continue ;	}
			path = buf.c_str() ;
			break ;
			}
		#endif
		}
	return	path ;
	}

////
//	*******************************************************************************
//	ask file
//	Create	:	2021/07/06
//	*******************************************************************************
inline	tstring	ask_file	(LPCTSTR title,LPCTSTR filter=OFN_filter_All)
{
	tstring	path ;
	while(true)	{
		#ifdef	_WIN32
		{
			HWND	hwnd = ::GetConsoleHwnd() ;
			static	tstring		buf ;
			buf = ::W_get_remote_name(  buf.c_str()) ;
			buf = ::FD_GetOpenFile(hwnd,buf.c_str(),filter,title) ;
			if (buf.empty())			{	break ;		}
			path = buf.c_str() ;
			break ;
			}
		#else
		{
			tstring	buf ;
			buf.resize(1000) ;
			tstring	msg = tstring(title) + _T(" =") ;
			std::terr << msg ;
			std::tin.getline(&buf[0],std::streamsize(buf.size())) ;
			buf = ::QuotM_Del_All(buf.c_str()) ;
			if		(buf == _T("q"))	{	break ;		}
			else if (buf == _T("Q"))	{	break ;		}
			if (buf.empty())			{	continue ;	}
			path = buf.c_str() ;
			break ;
			}
		#endif
		}
	return	path ;
	}

////
//	*******************************************************************************
//	ask folder
//	Create	:	2021/07/21
//	*******************************************************************************
inline	tstring	ask_folder	(LPCTSTR def_fold)
{
	tstring	fold ;
	while(true)	{
		#ifdef	_WIN32
		{
			HWND	hwnd = ::GetConsoleHwnd() ;
			tstring	buf = def_fold ;
			buf = ::W_get_remote_name(  buf.c_str()) ;
			buf = ::Browse_Folder (hwnd,buf.c_str()) ;
			if (buf.empty())			{	break ;		}
			fold = buf.c_str() ;
			break ;
			}
		#else
		{
			tstring	buf ;
			buf.resize(1000) ;
			tstring	msg = _T("folder  =") ;
			std::terr << msg ;
			std::tin.getline(&buf[0],std::streamsize(buf.size())) ;
			buf = ::QuotM_Del_All(buf.c_str()) ;
			if		(buf == _T("q"))	{	break ;		}
			else if (buf == _T("Q"))	{	break ;		}
			if (buf.empty())			{	continue ;	}
			fold = buf.c_str() ;
			break ;
			}
		#endif
		}
	return	fold ;
	}

