//	*******************************************************************************
//	Name	:	lgmsgbox.hxx
//			:	Log or Message Box
//	Author	:	I. Nakagawa
//	Create	:	2016/10/21
//	Modify	:	2016/11/28	Add Mutex
//	*******************************************************************************

#pragma		once

#include	"i_trace.hxx"

#ifdef	_MFC_VER
#include	"ExclusS.hxx"
//#include	"HelpWAPI.hxx"
#endif

////
//	*******************************************************************************
//	logging message
//	Create	:	2016/10/21
//	Modify	:	2016/11/28	Add Mutex
//	*******************************************************************************
inline	bool	LogMessage	(LPCTSTR lpszText)
{
	#ifdef	_MFC_VER
	_MutexS_	mt(FALSE,_T("::LogMessage")) ;
	MutexS		m(&mt) ;
	{
		#ifdef	__AFXWIN_H__
		{
		//	tstring	modName = ::i_GetModuleFileName(AfxGetInstanceHandle()) ;	//	DLL name
			tstring	modName = ::Get_module_name    (AfxGetInstanceHandle()) ;	//	DLL name
			if (::Path_GetExtLow(modName) == _T("dll")) {
		//	static	BOOL	isDump = ::Profile_GetInt(_T("Debug"),_T("DLL::LogMessage"),FALSE) ;
		//	if (!isDump)	 {	return	false ;	}
				#ifdef	_DEBUG
				#else
				return	false ;
				#endif
				}
			}
		#endif
		return	::i_Trace(lpszText) ;
		}
	#endif
	{
		return	::i_Trace(lpszText) ;
		}
	}

inline	bool	LogMessage	(c_tstring& text)	{	return	::LogMessage(text.c_str()) ;	}

////
//	*******************************************************************************
//	logging message and AfxMessageBox
//	Create	:	2016/10/21
//	*******************************************************************************
#ifdef	_MFC_VER
inline	int	LogMessageBox	(LPCTSTR lpszText,UINT nType=MB_OK,UINT nIDHelp=0)
{
	int	type = nType & MB_TYPEMASK ;
	int	icon = nType & MB_ICONMASK ;
	int	defB = nType & MB_DEFMASK  ;
	int	mode = nType & MB_MODEMASK ;
	int	misc = nType & MB_MISCMASK ;
	int	defButton = IDOK ;
	switch	(type)	{
		case	MB_ABORTRETRYIGNORE :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDABORT ;	}
			else if	(defB == MB_DEFBUTTON2)	{	defButton = IDRETRY ;	}
			else if	(defB == MB_DEFBUTTON3)	{	defButton = IDIGNORE ;	}
			else							{	defButton = IDABORT ;	}
			break ;
		case	MB_OK :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDOK ;		}
			else							{	defButton = IDOK ;		}
			break ;
		case	MB_OKCANCEL :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDOK ;		}
			else if	(defB == MB_DEFBUTTON2)	{	defButton = IDCANCEL ;	}
			else							{	defButton = IDOK ;		}
			break ;
		case	MB_RETRYCANCEL :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDRETRY ;	}
			else if	(defB == MB_DEFBUTTON2)	{	defButton = IDCANCEL ;	}
			else							{	defButton = IDRETRY ;	}
			break ;
		case	MB_YESNO :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDYES ;		}
			else if	(defB == MB_DEFBUTTON2)	{	defButton = IDNO ;		}
			else							{	defButton = IDYES ;		}
			break ;
		case	MB_YESNOCANCEL :
			if		(defB == MB_DEFBUTTON1)	{	defButton = IDYES ;		}
			else if	(defB == MB_DEFBUTTON2)	{	defButton = IDNO ;		}
			else if	(defB == MB_DEFBUTTON3)	{	defButton = IDCANCEL ;	}
			else							{	defButton = IDYES ;		}
			break ;
		default :
			break ;
		}
	int	resButton = defButton ;
	{
		#ifdef	__AFXWIN_H__
		if (AfxGetMainWnd() != NULL) {
			resButton = ::AfxMessageBox(lpszText,nType,nIDHelp) ;
			}
		#endif
		}
	tstring	strIcon = _T("     ") ;
	tstring	strType = _T("                ") ;
	tstring	strDefB = _T("         ") ;
	tstring	strSelB = _T("        \t") ;
	switch	(icon) {
		case	MB_ICONEXCLAMATION	:	strIcon = _T("(!)  ") ;				break ;
		case	MB_ICONINFORMATION	:	strIcon = _T("(i)  ") ;				break ;
		case	MB_ICONQUESTION		:	strIcon = _T("(?)  ") ;				break ;
		case	MB_ICONSTOP			:	strIcon = _T("Stop ") ;				break ;
		default :						strIcon = _T("---- ") ;				break ;
		}
	switch	(type)	{
		case	MB_ABORTRETRYIGNORE :	strType = _T("AbortRetryInore ") ;	break ;
		case	MB_OK				:	strType = _T("OK              ") ;	break ;
		case	MB_OKCANCEL			:	strType = _T("OK Cancel       ") ;	break ;
		case	MB_RETRYCANCEL		:	strType = _T("Retry Cancel    ") ;	break ;
		case	MB_YESNO			:	strType = _T("Yes No          ") ;	break ;
		case	MB_YESNOCANCEL		:	strType = _T("Yes No Cancel   ") ;	break ;
		default	:						strType = _T("                ") ;	break ;
		}
	switch	(defB)	{
		case	MB_DEFBUTTON1		:	strDefB = _T("Button1  ") ;			break ;
		case	MB_DEFBUTTON2		:	strDefB = _T("Button2  ") ;			break ;
		case	MB_DEFBUTTON3		:	strDefB = _T("Button3  ") ;			break ;
		default	:						strDefB = _T("Non  (1) ") ;			break ;
		}
	switch	(resButton)	{
		case	IDABORT				:	strSelB = _T("[Abort] \t") ;		break ;
		case	IDCANCEL			:	strSelB = _T("[CANCEL]\t") ;		break ;
		case	IDIGNORE			:	strSelB = _T("[Innore]\t") ;		break ;
		case	IDNO				:	strSelB = _T("[No]    \t") ;		break ;
		case	IDOK				:	strSelB = _T("[OK]    \t") ;		break ;
		case	IDRETRY				:	strSelB = _T("[Retry] \t") ;		break ;
		case	IDYES				:	strSelB = _T("[Yes]   \t") ;		break ;
		default :						strSelB = _T("Bug...  \t") ;		break ;
		}
	tstring	writeStr = (strIcon + strType + strDefB + strSelB) + _T("\r\n") ;
			writeStr+= tstring(lpszText) + _T("\r\n") ;
	::LogMessage(writeStr.c_str()) ;
	return	resButton ;
	}

inline	int		LogMessageBox	(c_tstring& text,UINT nType=MB_OK,	UINT nIDHelp=0)		{	return	::LogMessageBox	(text.c_str(),nType,nIDHelp) ;	}
#else
inline	int		LogMessageBox	(c_tstring& text,u_16 nType=0,		u_16 nIDHelp=0)		{	return	::LogMessage	(text.c_str()) ;	}
#endif
