//	*******************************************************************************
//	Name	:	str_CLI.hxx
//			:	String	C++/CLI <--> STL
//	Author	:	I. Nakagawa
//	Create	:	2013/08/07
//	Modify	:	2014/10/02		support MBCS
//	Create	:	2022/11/28		add v_tstring
//	Modify	:	2022/11/30		>=	VC 10
//	*******************************************************************************

#pragma		once

#ifdef		__cplusplus_cli

#using		<System.dll>

#include	<vcclr.h>
#include	"v_tstrng.hxx"

#ifdef		_UNICODE
#else
//	#pragma	message	("CLI <--> STL    MBCS     No Support")
#include	"tstrmbwc.hxx"
#endif

////
//	*******************************************************************************
//	STL	-->	CLI
//	Create	:	2013/08/07
//	*******************************************************************************
inline	System::String^	to_gcString	(LPCTSTR	str)	{	return	gcnew	System::String(str) ;	}
inline	System::String^	to_gcString	(c_tstring&	str)	{	return	::to_gcString(str.c_str()) ;	}
#define	gcString		to_gcString

////
//	*******************************************************************************
//	CLI	-->	STL
//	Create	:	2013/08/07
//	Modify	:	2014/10/02		support MBCS
//	Modify	:	2022/11/30		check nullptr		>=	VC 10
//	*******************************************************************************
inline	tstring	to_tstring	(System::String^ str)	{
#if	_MSC_VER	>=	1600
	if (str == nullptr)					{	return	_T("") ;	}
#endif
	if (str == System::String::Empty)	{	return	_T("") ;	}
//	const _wchar_t	__pin*	pStr = PtrToStringChars(str) ;
	pin_ptr	<const wchar_t>	pStr = PtrToStringChars(str) ;
	tstring	tstr ;
	#ifdef		_UNICODE
			tstr = pStr ;
	#else
			tstr = ::To_tstring(pStr) ;
	#endif
	return	tstr ;
	}

////
//	*******************************************************************************
//	STL	-->	CLI
//	Create	:	2022/11/28
//	*******************************************************************************
inline	array<System::String^>^	to_gcString	(v_tstring& v_str)
{
	int	a_size = int(v_str.size()) ;
	array<System::String^>^	ary_str = gcnew	array<System::String^>(a_size) ;
	for (int index=0 ; index<int(v_str.size()) ; index++) {
		System::String^	str = ::to_gcString(v_str[index]) ;
		ary_str[index] = str ;
		}
	return	ary_str ;
	}

////
//	*******************************************************************************
//	CLI	-->	STL
//	Create	:	2022/11/28
//	*******************************************************************************
inline	v_tstring	to_tstring	(array<System::String^>^ str_ary)
{
	v_tstring	v_str ;
	for (int index=0 ; index<str_ary->GetLength(0) ; index++) {
		tstring	str = ::to_tstring(str_ary[index]) ;
		v_str.push_back(str) ;
		}
	return	v_str ;
	}

#endif	//	__cplusplus_cli
