//	*******************************************************************************
//	Name	:	vchrfile.hxx
//			:	File Access
//	Author	:	I. Nakagawa
//	Create	:	2019/12/27
//	Modify	:	2019/12/27
//	*******************************************************************************

#pragma		once

#include	"i_v_type.hxx"
#include	"openfile.hxx"
#include	"filestat.hxx"
#include	"log_msg.hxx"

////
//	*******************************************************************************
//	Load File
//	Create	:	2014/02/10
//	Modify	:	2019/12/27
//	*******************************************************************************
inline	v_char	v_c_Load	(LPCTSTR pathName)
{
	v_char	text ;
	FILE*	ifp = ::Open_File(pathName,_T("rb")) ;
	if (ifp == NULL)	{
		::Log_Message((tstring(_T("Can't open rb  "))+pathName).c_str()) ;
		return	text ;
		}
	size_t	fSize = size_t(F_Stat::GetSize(pathName)) ;
	text.resize(fSize) ;
	if (fSize > 0)	{
		::fread(&text[0],sizeof(char),fSize,ifp) ;
		}
	::fclose(ifp) ;
	return	text ;
	}

////
//	*******************************************************************************
//	Save File
//	Create	:	2014/02/10
//	Modify	:	2019/12/27
//	*******************************************************************************
inline	bool	v_c_Save	(LPCTSTR pathName,c_v_char text,const long count=0)
{
	FILE*	ofp = ::Open_File(pathName,_T("wb")) ;
	if (ofp == NULL)	{
		::Log_Message((tstring(_T("Can't open wb  "))+pathName).c_str()) ;
		return	false ;
		}
	if (text.size() > 0) {
		::fwrite(&text[0],sizeof(char),text.size(),ofp) ;
		}
	::fclose(ofp) ;
	if (text.size() > 0) {
		u_64	fSize =F_Stat::GetSize(pathName) ;
		if (fSize == 0)	{
			if (count > 10)		{	return	false ;		}
			::Sleep_ms(10) ;	//	10 ms
			return	::v_c_Save	(pathName,text,count+1) ;
			}
		}
	return	true ;
	}
